from learner import Learner
import torch

# its for initial test

def checkrow(row):
    if len(row) == 0:
        return None
    if row[0] is None:
        return None

    for x in row:
        if x != row[0]:
            return None

    return row[0]

class TicTacToe:
    def __init__(self, W, H, L):
        self.W = W
        self.H = H
        self.L = L
        self.board = [None for i in range(W*H)]

    def get(self, x, y):
        return self.board[x + y*self.W]

    def state(self, pl):
        return [item for it in [
            [
                1 if x == pl else 0,
                1 if x is not None and x != pl else 0
            ]
            for x in self.board
        ] for item in it]

    def actions(self):
        return [(x,y) if self.get(x,y) is None else None
                for y in range(self.H)
                for x in range(self.W)]

    def print(self):
        print("===")
        for y in range(self.H):
            print("  " + (' '.join([str(self.get(x,y))
                                    if self.get(x,y) is not None else '.'
                                    for x in range(self.W)])))
        print("===")

    def play(self, x, y, pl):
        v = self.get(x, y)

        if v is not None:
            return None

        self.board[x + y*self.W] = pl

        # rows
        for x, y in [(x,y)
                     for y in range(self.H)
                     for x in range(self.W - self.L + 1)]:
            row = [self.get(x+d, y)
                   for d in range(self.L)]
            row = checkrow(row)
            if row is not None:
                return (True, row)

        # cols
        for x, y in [(x,y)
                     for y in range(self.H - self.L + 1)
                     for x in range(self.W)]:
            col = [self.get(x, y+d)
                   for d in range(self.L)]
            col = checkrow(col)
            if col is not None:
                return (True, col)

        # diags
        for x, y in [(x,y)
                     for y in range(self.H - self.L + 1)
                     for x in range(self.W - self.L + 1)]:
            dia1 = [self.get(x+dx, y+dy)
                    for dy in range(self.L)
                    for dx in range(self.L)]
            dia2 = [self.get(x+self.L-1-dx, y+dy)
                    for dy in range(self.L)
                    for dx in range(self.L)]
            dia1 = checkrow(dia1)
            dia2 = checkrow(dia2)
            if dia1 is not None:
                return (True, dia1)
            if dia2 is not None:
                return (True, dia2)

        if len([i for i in filter(lambda x: x is not None, self.actions())]) == 0:
            return (True, None)

        return (False, None)


W = 3
H = 3
L = 3

game = TicTacToe(W,H,L)

state = None

try:
    state = torch.load("model-ttt.pt", weights_only = True)
except:
    pass

agent = Learner(len(game.actions()), len(game.state(1)), state = state)

players = [1,2]
states = [None for pl in players]
acts = [None for pl in players]
next_states = [None for pl in players]

while True:
    for i, pl in enumerate(players):
        print()
        states[i] = game.state(pl)
        next_states[i] = None
        state = states[i]

        act = None
        actions = game.actions()
        while act is None:
            act = agent.decide(state)
            if actions[act] is None:
                print('badact', act)
                agent.learn(state, act, None, -0.5)
                act = None

        acts[i] = act

        term, winner = game.play(actions[act][0], actions[act][1], pl)
        print("state:",(term,winner))
        next_states[i] = game.state(pl)

        other_reward = 0
        if term and winner == pl:
            print()
            print("@@@@")
            print("@@@@")
            print("@@@@ WINNER :"+str(pl)+" @@@@")
            print("@@@@")
            print("@@@@")
            print()
            other_reward = -1
            print('learn', 1)
            agent.learn(states[i], acts[i], next_states[i], 1)
        elif term:
            print('learn', 0)
            agent.learn(states[i], acts[i], next_states[i], 0)


        for j, pln in filter(lambda p: p[1] != pl, enumerate(players)):
            if acts[j] is not None:
                print('learn', other_reward)
                agent.learn(states[j], acts[j], next_states[j], other_reward)

        game.print()

        if term:
            states = [None for pl in players]
            acts = [None for pl in players]
            next_states = [None for pl in players]
            game = TicTacToe(W,H,L)
            torch.save(agent.get_model_state(), "model-ttt.pt")
            break
